var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var taskagentbasem = require('./TaskAgentApiBase');
var url = require('url');
var Q = require("q");
var TaskAgentApi = (function (_super) {
    __extends(TaskAgentApi, _super);
    function TaskAgentApi(baseUrl, handlers) {
        _super.call(this, baseUrl, handlers);
        this._handlers = handlers;
    }
    TaskAgentApi.prototype.deleteTaskDefinition = function (taskId, onResult) {
        var _this = this;
        this.vsoClient.beginGetLocation("distributedtask", "60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd")
            .then(function (location) {
            if (location) {
                _super.prototype.deleteTaskDefinition.call(_this, taskId, onResult);
            }
            else {
                var fallbackClient = _this._getFallbackClient(_this.baseUrl);
                if (!fallbackClient) {
                    throw new Error("Failed to find api location for area: distributedtask id: 60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd");
                }
                else {
                    fallbackClient.deleteTaskDefinition(taskId, onResult);
                }
            }
        })
            .fail(function (error) {
            onResult(error, error.statusCode);
        });
    };
    TaskAgentApi.prototype.getTaskContentZip = function (taskId, versionString, visibility, scopeLocal, onResult) {
        var _this = this;
        this.vsoClient.beginGetLocation("distributedtask", "60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd")
            .then(function (location) {
            if (location) {
                _super.prototype.getTaskContentZip.call(_this, taskId, versionString, visibility, scopeLocal, onResult);
            }
            else {
                var fallbackClient = _this._getFallbackClient(_this.baseUrl);
                if (!fallbackClient) {
                    throw new Error("Failed to find api location for area: distributedtask id: 60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd");
                }
                else {
                    fallbackClient.getTaskContentZip(taskId, versionString, visibility, scopeLocal, onResult);
                }
            }
        })
            .fail(function (error) {
            onResult(error, error.statusCode, null);
        });
    };
    TaskAgentApi.prototype.getTaskDefinition = function (taskId, versionString, visibility, scopeLocal, onResult) {
        var _this = this;
        this.vsoClient.beginGetLocation("distributedtask", "60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd")
            .then(function (location) {
            if (location) {
                _super.prototype.getTaskDefinition.call(_this, taskId, versionString, visibility, scopeLocal, onResult);
            }
            else {
                var fallbackClient = _this._getFallbackClient(_this.baseUrl);
                if (!fallbackClient) {
                    throw new Error("Failed to find api location for area: distributedtask id: 60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd");
                }
                else {
                    fallbackClient.getTaskDefinition(taskId, versionString, visibility, scopeLocal, onResult);
                }
            }
        })
            .fail(function (error) {
            onResult(error, error.statusCode, null);
        });
    };
    TaskAgentApi.prototype.getTaskDefinitions = function (taskId, visibility, scopeLocal, onResult) {
        var _this = this;
        this.vsoClient.beginGetLocation("distributedtask", "60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd")
            .then(function (location) {
            if (location) {
                _super.prototype.getTaskDefinitions.call(_this, taskId, visibility, scopeLocal, onResult);
            }
            else {
                var fallbackClient = _this._getFallbackClient(_this.baseUrl);
                if (!fallbackClient) {
                    throw new Error("Failed to find api location for area: distributedtask id: 60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd");
                }
                else {
                    fallbackClient.getTaskDefinitions(taskId, visibility, scopeLocal, onResult);
                }
            }
        })
            .fail(function (error) {
            onResult(error, error.statusCode, null);
        });
    };
    TaskAgentApi.prototype.uploadTaskDefinition = function (customHeaders, contentStream, taskId, overwrite, onResult) {
        var _this = this;
        this.vsoClient.beginGetLocation("distributedtask", "60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd")
            .then(function (location) {
            if (location) {
                _this._uploadTaskDefinition(customHeaders, contentStream, taskId, overwrite, onResult);
            }
            else {
                var fallbackClient = _this._getFallbackClient(_this.baseUrl);
                if (!fallbackClient) {
                    throw new Error("Failed to find api location for area: distributedtask id: 60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd");
                }
                else {
                    fallbackClient._uploadTaskDefinition(customHeaders, contentStream, taskId, overwrite, onResult);
                }
            }
        })
            .fail(function (error) {
            onResult(error, error.statusCode, null);
        });
    };
    TaskAgentApi.prototype._uploadTaskDefinition = function (customHeaders, contentStream, taskId, overwrite, onResult) {
        var _this = this;
        var routeValues = {
            taskId: taskId
        };
        var queryValues = {
            overwrite: overwrite
        };
        customHeaders = customHeaders || {};
        customHeaders["Content-Type"] = "application/octet-stream";
        this.vsoClient.getVersioningData("3.0-preview.1", "distributedtask", "60aac929-f0cd-4bc8-9ce4-6b30e8f1b1bd", routeValues, queryValues)
            .then(function (versioningData) {
            var url = versioningData.requestUrl;
            var apiVersion = versioningData.apiVersion;
            var serializationData = { responseIsCollection: false };
            _this.restClient.uploadStream('PUT', url, apiVersion, contentStream, customHeaders, serializationData, onResult);
        })
            .fail(function (error) {
            onResult(error, error.statusCode, null);
        });
    };
    TaskAgentApi.prototype._getFallbackClient = function (baseUrl) {
        if (!this._fallbackClient) {
            var accountUrl = this._getAccountUrl(baseUrl);
            if (accountUrl) {
                this._fallbackClient = new TaskAgentApi(accountUrl, this._handlers);
            }
        }
        return this._fallbackClient;
    };
    TaskAgentApi.prototype._getAccountUrl = function (collectionUrl) {
        var purl = url.parse(collectionUrl);
        if (!purl.protocol || !purl.host) {
            return null;
        }
        var accountUrl = purl.protocol + '//' + purl.host;
        var splitPath = purl.path.split('/').slice(1);
        if (splitPath.length === 0 || (splitPath.length === 1 && splitPath[0] === '')) {
            return null;
        }
        if (splitPath[0] === 'tfs' && (splitPath.length === 2 || (splitPath.length === 3 && splitPath[2].length === 0))) {
            accountUrl += '/' + 'tfs';
        }
        else if (splitPath.length === 2 && splitPath[0] === '') {
            return accountUrl;
        }
        else if (splitPath.length > 1) {
            return null;
        }
        return accountUrl;
    };
    return TaskAgentApi;
})(taskagentbasem.TaskAgentApiBase);
exports.TaskAgentApi = TaskAgentApi;
var QTaskAgentApi = (function (_super) {
    __extends(QTaskAgentApi, _super);
    function QTaskAgentApi(baseUrl, handlers) {
        _super.call(this, baseUrl, handlers, TaskAgentApi);
    }
    QTaskAgentApi.prototype.uploadTaskDefinition = function (customHeaders, contentStream, taskId, overwrite) {
        var deferred = Q.defer();
        this.api.uploadTaskDefinition(customHeaders, contentStream, taskId, overwrite, function (err, statusCode) {
            if (err) {
                err.statusCode = statusCode;
                deferred.reject(err);
            }
            else {
                deferred.resolve(null);
            }
        });
        return deferred.promise;
    };
    return QTaskAgentApi;
})(taskagentbasem.QTaskAgentApiBase);
exports.QTaskAgentApi = QTaskAgentApi;
